/*
 *  This file is part of PPP-Codes library: http://disa.fi.muni.cz/results/software/ppp-codes/
 *
 *  PPP-Codes library is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  PPP-Codes library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with PPP-Codes library.  If not, see <http://www.gnu.org/licenses/>.
 */
package pppcodes.ids;

import java.io.Serializable;

/**
 * This is an interface defining a String-int and int-String reversible convertor for unique object
 *  locators which is used within the PPP-Codes to save space.
 * 
 * @author David Novak, Masaryk University, Brno, Czech Republic, novak.david@gmail.com
 */
public interface LocatorStringIntConvertor extends Serializable {
  
    /**
     * Given a string locator, this method generates a unique positive integer ID.
     * @param locator string locator to get int ID for
     * @return unique integer value for given string (data object locator)
     */
    public int getIntLocator(String locator);
    
    /**
     * Given a generated unique integer ID this method returns the original string
     *  object locator for which this ID was generated by complementary 
     * {@link LocatorStringIntTranslator#getIntLocator(java.lang.String) }
     * If this ID wasn't generated, null is returned.
     * @param id integer value to get the original String locator for
     * @return original String locator generated for given ID or null
     */
    public String getStringLocator(int id);
    
    /**
     * Returns the maximal number 
     */
    
}
